/* 
 * $RCSfile: gj_agents.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/12 20:23:50 $
 * 
 * $Revision: 1.4 $ 
 *
 */

#ifndef __gj_agents_h
#define __gj_agents_h

#include <glib.h>

#include <libxml/tree.h>

typedef struct t_agent *agent;

typedef void (*agentCallback)(GList *agents, gint error_code, gchar *error_message);

/* list functions */
gboolean gj_agent_init();
gboolean gj_agent_term();

/* list functions */
GList *gj_agent_list_get();

/* item functions */
agent gj_agent_new(gchar *jid);
void gj_agent_free(agent ag);

gboolean gj_agent_set_jid(agent ag, gchar *jid);
gboolean gj_agent_set_name(agent ag, gchar *name);
gboolean gj_agent_set_description(agent ag, gchar *description);
gboolean gj_agent_set_transport(agent ag, gchar *transport);
gboolean gj_agent_set_groupchat(agent ag, gchar *groupchat);
gboolean gj_agent_set_service(agent ag, gchar *service);
gboolean gj_agent_set_registers(agent ag, gchar *registers);
gboolean gj_agent_set_search(agent ag, gchar *search);

gchar *gj_agent_get_jid(agent ag);
gchar *gj_agent_get_name(agent ag);
gchar *gj_agent_get_description(agent ag);
gchar *gj_agent_get_transport(agent ag);
gchar *gj_agent_get_groupchat(agent ag);
gchar *gj_agent_get_service(agent ag);
gchar *gj_agent_get_registers(agent ag);
gchar *gj_agent_get_search(agent ag);

gboolean gj_agent_list_request(gchar *server, agentCallback cb);

agent gj_agent_find_by_name(gchar *name);
agent gj_agent_find_by_jid(gchar *jid);

/* debugging */
void gj_agent_print(agent ag);
void gj_agent_list_print();

#endif

