/* 
 * $RCSfile: gj_gtk_chat.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/08/23 11:17:26 $
 * 
 * $Revision: 1.8 $
 *
 */

#ifndef __gj_gtk_chat_h
#define __gj_gtk_chat_h

typedef struct t_ChatWindow *ChatWindow;

ChatWindow gj_gtk_cw_find_by_id(gint id);
ChatWindow gj_gtk_cw_find_by_ri_id(gint id);
ChatWindow gj_gtk_cw_find_by_widget(GtkWidget *widget);
ChatWindow gj_gtk_cw_find_by_last_recv_x_event_id(gchar *message_id);
ChatWindow gj_gtk_cw_find_by_last_sent_x_event_id(gchar *message_id);
ChatWindow gj_gtk_cw_find_by_thread(gchar *thread);

void gj_gtk_cw_print_all();
void gj_gtk_cw_print(ChatWindow cw);

/* 
 * member functions 
 */

/* gets */
gint gj_gtk_cw_get_id(ChatWindow cw);

gint gj_gtk_cw_get_ri_id(ChatWindow cw);

gchar *gj_gtk_cw_get_nickname(ChatWindow cw);
gchar *gj_gtk_cw_get_groups(ChatWindow cw);
gchar *gj_gtk_cw_get_thread(ChatWindow cw);

GtkTreeIter *gj_gtk_cw_get_iter(ChatWindow cw);

gboolean gj_gtk_cw_get_reverse_text_direction(ChatWindow cw);

gint gj_gtk_cw_get_last_recv_x_event_type(ChatWindow cw);
gchar *gj_gtk_cw_get_last_recv_x_event_id(ChatWindow cw);

gint gj_gtk_cw_get_last_sent_x_event_type(ChatWindow cw);
gchar *gj_gtk_cw_get_last_sent_x_event_id(ChatWindow cw);

guint gj_gtk_cw_get_composing_timeout_id(ChatWindow cw);
gboolean gj_gtk_cw_get_composing_timeout_stop(ChatWindow cw);

gboolean gj_gtk_cw_get_is_composing(ChatWindow cw);
gint gj_gtk_cw_get_composing_duration(ChatWindow cw);
gint gj_gtk_cw_get_composing_stopped(ChatWindow cw);

/* sets */
gboolean gj_gtk_cw_set_ri_id(ChatWindow cw, gint id);

gboolean gj_gtk_cw_set_nickname(ChatWindow cw, gchar *nickname);
gboolean gj_gtk_cw_set_groups(ChatWindow cw, gchar *groups);
gboolean gj_gtk_cw_set_thread(ChatWindow cw, gchar *thread);

gboolean gj_gtk_cw_set_reverse_text_direction(ChatWindow cw, gboolean reverse_text_direction);

gboolean gj_gtk_cw_set_last_recv_x_event_type(ChatWindow cw, gint type);
gboolean gj_gtk_cw_set_last_recv_x_event_id(ChatWindow cw, gchar *id);

gboolean gj_gtk_cw_set_last_sent_x_event_type(ChatWindow cw, gint type);
gboolean gj_gtk_cw_set_last_sent_x_event_id(ChatWindow cw, gchar *id);

gboolean gj_gtk_cw_set_composing_timeout_id(ChatWindow cw, guint id);
gboolean gj_gtk_cw_set_composing_timeout_stop(ChatWindow cw, gboolean stop);

gboolean gj_gtk_cw_set_is_composing(ChatWindow cw, gboolean composing);
gboolean gj_gtk_cw_set_composing_duration(ChatWindow cw, gint duration);
gboolean gj_gtk_cw_set_composing_stopped(ChatWindow cw, gint stopped);

/* 
 * window functions 
 */
ChatWindow gj_gtk_cw_notification_new(gint ri_id, message msg);
void gj_gtk_cw_notification_of_x_event_new(ChatWindow cw, message msg);
void gj_gtk_cw_default_action(rosterItem ri); 

ChatWindow gj_gtk_cw_receive_new(rosterItem ri);
ChatWindow gj_gtk_cw_send_new(rosterItem ri);

gboolean gj_gtk_cw_show(ChatWindow cw, gboolean show);

gboolean gj_gtk_cw_presence_update(rosterItem ri, presence pres);


#endif
