/* 
 * $RCSfile: gj_gtk_connection_settings.c,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/31 16:43:54 $
 * 
 * $Revision: 1.15 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "common.h"

#include "gj_main.h"
#include "gj_me.h"
#include "gj_config.h"

#include "gj_gtk_connection_settings.h"
#include "gj_gtk_connection_progress.h"
#include "gj_gtk_password_change.h"
#include "gj_gtk_roster.h"

struct 
{
  GtkWidget *window;

  GtkWidget *vbox_account;
  GtkWidget *vbox_options;

  GtkWidget *combo_server;
  GtkWidget *combo_entry_server;
/*   GtkWidget *entry_server; */
  GtkWidget *spinbutton_port;
  GtkWidget *entry_username;
  GtkWidget *entry_password;

  GtkWidget *entry_nickname;
  GtkWidget *entry_resource;
  GtkWidget *spinbutton_priority;

  GtkWidget *label_server;
  GtkWidget *label_port;
  GtkWidget *label_username;
  GtkWidget *label_password;

  GtkWidget *label_nickname;
  GtkWidget *label_resource;
  GtkWidget *label_priority;

  GtkWidget *frame_account_options;
  GtkWidget *hseparator;
  
  GtkWidget *checkbutton_save_password;
  GtkWidget *checkbutton_use_plain_text_password;
  GtkWidget *checkbutton_use_ssl;

  GtkWidget *checkbutton_auto_connect_on_startup;
  GtkWidget *checkbutton_auto_reconnect_on_disconnect;

  GtkWidget *notebook;

  GtkWidget *button_ok;
  GtkWidget *button_apply;
  GtkWidget *button_cancel;

} ctlCS;

struct
{
  gchar *server;
  gint16 port;
  gchar *username;
  gchar *password;

  gchar *nickname;
  gchar *resource;
  gint8 priority;

  gboolean save_password;
  gboolean use_plain_text_password;
  gboolean use_ssl;
  gboolean auto_connect_on_startup;
  gboolean auto_reconnect_on_disconnect;

  /* option set my calling load_and_connect() */
  gboolean connect_on_close;

} optCS;

/* local functions */
gboolean gj_gtk_cs_setup();


/*
 * gui callbacks
 */ 
void on_checkbutton_cs_save_password_toggled(GtkToggleButton *togglebutton, gpointer user_data);

void on_button_cs_ok_clicked(GtkButton *button, gpointer user_data);
void on_button_cs_apply_clicked(GtkButton *button, gpointer user_data);
void on_button_cs_cancel_clicked(GtkButton *button, gpointer user_data);

gboolean on_connection_settings_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data);

/*
 * code
 */
gboolean gj_gtk_cs_load()
{
  GladeXML *xml = NULL;

  if((xml = glade_xml_new(gnome_jabber_get_glade_file(),
			  "connection_settings",
			  NULL)) == NULL)
    {
      g_warning("gj_gtk_cs_load: couldn't open glade file at root 'connection_settings'");
      return FALSE;
    }
  
  ctlCS.window = glade_xml_get_widget(xml,"connection_settings");

  ctlCS.vbox_account = glade_xml_get_widget(xml,"vbox_cs_account");
  ctlCS.vbox_options = glade_xml_get_widget(xml,"vbox_cs_options");

  ctlCS.combo_server = glade_xml_get_widget(xml,"combo_cs_server");
  ctlCS.combo_entry_server = glade_xml_get_widget(xml,"combo-entry_cs_server");
/*   ctlCS.entry_server = glade_xml_get_widget(xml,"entry_cs_server"); */
  ctlCS.spinbutton_port = glade_xml_get_widget(xml,"spinbutton_cs_port");
  ctlCS.entry_username = glade_xml_get_widget(xml,"entry_cs_username");
  ctlCS.entry_password = glade_xml_get_widget(xml,"entry_cs_password");

  ctlCS.entry_nickname = glade_xml_get_widget(xml,"entry_cs_nickname");
  ctlCS.entry_resource = glade_xml_get_widget(xml,"entry_cs_resource");
  ctlCS.spinbutton_priority = glade_xml_get_widget(xml,"spinbutton_cs_priority");

  ctlCS.label_server = glade_xml_get_widget(xml,"label_cs_server");
  ctlCS.label_port = glade_xml_get_widget(xml,"label_cs_port");
  ctlCS.label_username = glade_xml_get_widget(xml,"label_cs_username");
  ctlCS.label_password = glade_xml_get_widget(xml,"label_cs_password");

  ctlCS.label_nickname = glade_xml_get_widget(xml,"label_cs_nickname");
  ctlCS.label_resource = glade_xml_get_widget(xml,"label_cs_resource");
  ctlCS.label_priority = glade_xml_get_widget(xml,"label_cs_priority");

  ctlCS.frame_account_options = glade_xml_get_widget(xml,"frame_cs_account_options");
  ctlCS.hseparator = glade_xml_get_widget(xml,"hseparator_cs_account");

  ctlCS.checkbutton_save_password = glade_xml_get_widget(xml,"checkbutton_cs_save_password");
  ctlCS.checkbutton_use_plain_text_password = glade_xml_get_widget(xml,"checkbutton_cs_use_plain_text_password");
  ctlCS.checkbutton_use_ssl = glade_xml_get_widget(xml,"checkbutton_cs_use_ssl");

  ctlCS.checkbutton_auto_connect_on_startup = glade_xml_get_widget(xml,"checkbutton_cs_auto_connect_on_startup");
  ctlCS.checkbutton_auto_reconnect_on_disconnect = glade_xml_get_widget(xml,"checkbutton_cs_auto_reconnect_on_disconnect");

  ctlCS.notebook = glade_xml_get_widget(xml,"notebook_cs");

  ctlCS.button_ok = glade_xml_get_widget(xml,"button_cs_ok");
  ctlCS.button_apply = glade_xml_get_widget(xml,"button_cs_apply");
  ctlCS.button_cancel = glade_xml_get_widget(xml,"button_cs_cancel");
  
  gdk_window_set_decorations (GDK_WINDOW(ctlCS.window->window), 
			      GDK_DECOR_BORDER | GDK_DECOR_TITLE | GDK_DECOR_MENU);

#ifndef WIN32
  glade_xml_signal_autoconnect(xml);
#else
  g_signal_connect ((gpointer) ctlCS.window, "delete_event",
		    G_CALLBACK (on_connection_settings_delete_event),
		    NULL);
  g_signal_connect ((gpointer) ctlCS.checkbutton_save_password, "toggled",
                    G_CALLBACK (on_checkbutton_cs_save_password_toggled),
                    NULL);
  g_signal_connect ((gpointer) ctlCS.button_cancel, "clicked",
		    G_CALLBACK (on_button_cs_cancel_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlCS.button_apply, "clicked",
		    G_CALLBACK (on_button_cs_apply_clicked),
		    NULL);
  g_signal_connect ((gpointer) ctlCS.button_ok, "clicked",
		    G_CALLBACK (on_button_cs_ok_clicked),
		    NULL);
#endif

  gj_gtk_cs_setup();

  /* get settings */
  gj_gtk_cs_open();
  gj_gtk_cs_get();

  optCS.connect_on_close = FALSE;

  /* clean up */
  if(xml != NULL)
    {
      g_object_unref(G_OBJECT(xml));
      xml = NULL;
    }

  return TRUE;
}

gboolean gj_gtk_cs_setup()
{
  GList *servers = NULL;
  const gchar **server_listing = NULL;
  const gchar *str = NULL;
  gint i = 0;

  server_listing = gnome_jabber_get_server_list();
  
  /* set a limit of a 1000 */
  while((str = server_listing[i++]) != NULL && i < 1000)
      servers = g_list_append(servers, (gchar*)str);

  gtk_combo_set_popdown_strings(GTK_COMBO(ctlCS.combo_server), servers);

  /* cleanup */
  g_list_free(servers);
  return TRUE;
}

gboolean gj_gtk_cs_unload()
{
  if(ctlCS.window == NULL) 
    return TRUE;

  gtk_widget_destroy(ctlCS.window);

  ctlCS.window = NULL;

  return TRUE;
}

gboolean gj_gtk_cs_get()
{
  /* set up settings */
  if(gj_gtk_cs_get_server() != NULL)
    gtk_entry_set_text(GTK_ENTRY(ctlCS.combo_entry_server), gj_gtk_cs_get_server());
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(ctlCS.spinbutton_port), (gdouble)gj_gtk_cs_get_port());

  if(gj_gtk_cs_get_username() != NULL)
    gtk_entry_set_text(GTK_ENTRY(ctlCS.entry_username), gj_gtk_cs_get_username());
  if(gj_gtk_cs_get_password() != NULL)
    gtk_entry_set_text(GTK_ENTRY(ctlCS.entry_password), gj_gtk_cs_get_password());

  if(gj_gtk_cs_get_nickname() != NULL)
    gtk_entry_set_text(GTK_ENTRY(ctlCS.entry_nickname), gj_gtk_cs_get_nickname());
  if(gj_gtk_cs_get_resource() != NULL)
    gtk_entry_set_text(GTK_ENTRY(ctlCS.entry_resource), gj_gtk_cs_get_resource());

  gtk_spin_button_set_value(GTK_SPIN_BUTTON(ctlCS.spinbutton_priority), (gdouble)gj_gtk_cs_get_priority());

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_save_password), gj_gtk_cs_get_save_password());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_use_plain_text_password), gj_gtk_cs_get_use_plain_text_password());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_use_ssl), gj_gtk_cs_get_use_ssl());

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_auto_connect_on_startup), gj_gtk_cs_get_auto_connect_on_startup());
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_auto_reconnect_on_disconnect), gj_gtk_cs_get_auto_reconnect_on_disconnect());

  return TRUE;
}

gboolean gj_gtk_cs_set()
{
    G_CONST_RETURN gchar *server = NULL;
    gint16 port = 0;
    G_CONST_RETURN gchar *username = NULL;
    G_CONST_RETURN gchar *password = NULL;

    G_CONST_RETURN gchar *nickname = NULL;
    G_CONST_RETURN gchar *resource = NULL;
    gint8 priority = 0;

    gboolean save_password = FALSE;
    gboolean use_plain_text_password = FALSE;
    gboolean use_ssl = FALSE;
    gboolean auto_connect_on_startup = FALSE;
    gboolean auto_reconnect_on_disconnect = FALSE;

    /* get values */
    server = gtk_entry_get_text(GTK_ENTRY(ctlCS.combo_entry_server));
    port = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(ctlCS.spinbutton_port));
    username = gtk_entry_get_text(GTK_ENTRY(ctlCS.entry_username));
    password = gtk_entry_get_text(GTK_ENTRY(ctlCS.entry_password));

    nickname = gtk_entry_get_text(GTK_ENTRY(ctlCS.entry_nickname));
    resource = gtk_entry_get_text(GTK_ENTRY(ctlCS.entry_resource));
    priority = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(ctlCS.spinbutton_priority));

    save_password = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_save_password));
    use_plain_text_password = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_use_plain_text_password));
    use_ssl = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_use_ssl));
    
    auto_connect_on_startup = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_auto_connect_on_startup));
    auto_reconnect_on_disconnect = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ctlCS.checkbutton_auto_reconnect_on_disconnect));

  /* check values */
  if(server == NULL || g_utf8_strlen(server, -1) < 1)
    {
      g_warning("gj_gtk_cs_set: server was NULL");
      return FALSE;
    }

  if(port < 1)
    {
      g_warning("gj_gtk_cs_set: port was < 1");
      return FALSE;
    }

  if(username == NULL || g_utf8_strlen(username, -1) < 1)
    {
      g_warning("gj_gtk_cs_set: username was NULL");
      return FALSE;
    }  

  if(password == NULL || g_utf8_strlen(password, -1) < 1)
    {
      g_warning("gj_gtk_cs_set: password was NULL");
      return FALSE;
    }

  /* set values */
  gj_gtk_cs_set_server((gchar*)server);
  gj_gtk_cs_set_port(port);
  gj_gtk_cs_set_username((gchar*)username);
  gj_gtk_cs_set_password((gchar*)password);

  gj_gtk_cs_set_nickname((gchar*)nickname);
  gj_gtk_cs_set_resource((gchar*)resource);
  gj_gtk_cs_set_priority(priority);

  gj_gtk_cs_set_save_password(save_password);
  gj_gtk_cs_set_use_plain_text_password(use_plain_text_password);
  gj_gtk_cs_set_use_ssl(use_ssl);
  gj_gtk_cs_set_auto_connect_on_startup(auto_connect_on_startup);
  gj_gtk_cs_set_auto_reconnect_on_disconnect(auto_reconnect_on_disconnect);

  return TRUE;
}

gboolean gj_gtk_cs_save()
{
  gj_config_set_cs_server(gj_gtk_cs_get_server());
  gj_config_set_cs_port(gj_gtk_cs_get_port());
  gj_config_set_cs_username(gj_gtk_cs_get_username());
  gj_config_set_cs_password(gj_gtk_cs_get_password());

  gj_config_set_cs_nickname(gj_gtk_cs_get_nickname());
  gj_config_set_cs_resource(gj_gtk_cs_get_resource());
  gj_config_set_cs_priority(gj_gtk_cs_get_priority());

  gj_config_set_cs_save_password(gj_gtk_cs_get_save_password());
  gj_config_set_cs_use_plain_text_password(gj_gtk_cs_get_use_plain_text_password());
  gj_config_set_cs_use_ssl(gj_gtk_cs_get_use_ssl());
  gj_config_set_cs_auto_connect_on_startup(gj_gtk_cs_get_auto_connect_on_startup());
  gj_config_set_cs_auto_reconnect_on_disconnect(gj_gtk_cs_get_auto_reconnect_on_disconnect());  

  gj_config_write();

  return TRUE;
}

gboolean gj_gtk_cs_open()
{
  /* load config */ 
  gj_config_read();

  gj_gtk_cs_set_server(gj_config_get_cs_server());
  gj_gtk_cs_set_port(gj_config_get_cs_port());
  gj_gtk_cs_set_username(gj_config_get_cs_username());
  gj_gtk_cs_set_password(gj_config_get_cs_password());

  gj_gtk_cs_set_nickname(gj_config_get_cs_nickname());
  gj_gtk_cs_set_resource(gj_config_get_cs_resource());
  gj_gtk_cs_set_priority(gj_config_get_cs_priority());

  gj_gtk_cs_set_save_password(gj_config_get_cs_save_password());
  gj_gtk_cs_set_use_plain_text_password(gj_config_get_cs_use_plain_text_password());
  gj_gtk_cs_set_use_ssl(gj_config_get_cs_use_ssl());
  gj_gtk_cs_set_auto_connect_on_startup(gj_config_get_cs_auto_connect_on_startup());
  gj_gtk_cs_set_auto_reconnect_on_disconnect(gj_config_get_cs_auto_reconnect_on_disconnect());

  return TRUE;
}

/*
 * member functions 
 */

/* gets */
gchar *gj_gtk_cs_get_server()
{
  return optCS.server;
}

gint16 gj_gtk_cs_get_port()
{
  return optCS.port;
}

gchar *gj_gtk_cs_get_username()
{
  return optCS.username;
}

gchar *gj_gtk_cs_get_password()
{
  return optCS.password;
}

gchar *gj_gtk_cs_get_nickname()
{
  return optCS.nickname;
}

gchar *gj_gtk_cs_get_resource()
{
  return optCS.resource;
}

gint8 gj_gtk_cs_get_priority()
{
  return optCS.priority;
}

gboolean gj_gtk_cs_get_save_password()
{
  return optCS.save_password;
}

gboolean gj_gtk_cs_get_use_plain_text_password()
{
  return optCS.use_plain_text_password;
}

gboolean gj_gtk_cs_get_use_ssl()
{
  return optCS.use_ssl;
}

gboolean gj_gtk_cs_get_auto_connect_on_startup()
{
  return optCS.auto_connect_on_startup;
}

gboolean gj_gtk_cs_get_auto_reconnect_on_disconnect()
{
  return optCS.auto_reconnect_on_disconnect;
}

/* sets */
gboolean gj_gtk_cs_set_server(gchar *server)
{
  if(server == NULL)
    {
      g_warning("gj_gtk_cs_set_server: server was NULL");
      return FALSE;
    }

  if(optCS.server != NULL)
    g_free(optCS.server);

  optCS.server = g_strdup(server);
  return TRUE;
}

gboolean gj_gtk_cs_set_port(gint16 port)
{
  if(port < 1024)
    {
      g_warning("gj_gtk_cs_set_port: port:%d was out of range",port);
      return FALSE;
    }

  optCS.port = port;
  return TRUE;
}

gboolean gj_gtk_cs_set_username(gchar *username)
{
  if(username == NULL)
    {
      g_warning("gj_gtk_cs_set_username: username was NULL");
      return FALSE;
    }

  if(optCS.username != NULL)
    g_free(optCS.username);

  optCS.username = g_strdup(username);
  return TRUE;
}

gboolean gj_gtk_cs_set_password(gchar *password)
{
  if(password == NULL)
    {
      g_warning("gj_gtk_cs_set_password: password was NULL");
      return FALSE;
    }

  if(optCS.password != NULL)
    g_free(optCS.password);

  optCS.password = g_strdup(password);
  return TRUE;
}

gboolean gj_gtk_cs_set_nickname(gchar *nickname)
{
  if(nickname == NULL)
    {
      g_warning("gj_gtk_cs_set_nickname: nickname was NULL");
      return FALSE;
    }

  if(optCS.nickname != NULL)
    g_free(optCS.nickname);

  optCS.nickname = g_strdup(nickname);
  return TRUE;
}

gboolean gj_gtk_cs_set_resource(gchar *resource)
{
  if(resource == NULL)
    {
      g_warning("gj_gtk_cs_set_resource: resource was NULL");
      return FALSE;
    }

  if(optCS.resource != NULL)
    g_free(optCS.resource);

  optCS.resource = g_strdup(resource);
  return TRUE;
}

gboolean gj_gtk_cs_set_priority(gint8 priority)
{
  optCS.priority = priority;
  return TRUE;
}


void gj_gtk_cs_set_save_password(gboolean value)
{
  optCS.save_password = value;
}

void gj_gtk_cs_set_use_plain_text_password(gboolean value)
{
  optCS.use_plain_text_password = value;
}

void gj_gtk_cs_set_use_ssl(gboolean value)
{
  optCS.use_ssl = value;
}

void gj_gtk_cs_set_auto_connect_on_startup(gboolean value)
{
  optCS.auto_connect_on_startup = value;
}

void gj_gtk_cs_set_auto_reconnect_on_disconnect(gboolean value)
{
  optCS.auto_reconnect_on_disconnect = value;
}

/*
 * GUI events
 */
void on_checkbutton_cs_save_password_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
    gtk_widget_set_sensitive(GTK_WIDGET(ctlCS.checkbutton_auto_reconnect_on_disconnect), gtk_toggle_button_get_active(togglebutton));
}

void on_button_cs_ok_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_cs_set();
  gj_gtk_cs_save();
  gj_gtk_cs_unload();

  if(optCS.connect_on_close == TRUE)
    gj_gtk_cp_load(gj_gtk_roster_cb_connected, gj_gtk_roster_cb_disconnected);
}

void on_button_cs_apply_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_cs_set();
  gj_gtk_cs_save();
}

void on_button_cs_cancel_clicked(GtkButton *button, gpointer user_data)
{
  gj_gtk_cs_unload();
}

gboolean on_connection_settings_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
  gj_gtk_cs_unload();

  return TRUE;
}

#ifdef __cplusplus
}
#endif
