/* 
 * $RCSfile: gj_gtk_message.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/08/19 00:52:08 $
 * 
 * $Revision: 1.4 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_gtk_message_h
#define __gj_gtk_message_h

typedef enum {
  
  MsgWindowTypeIncoming = 1,
  MsgWindowTypeOutgoing,
  MsgWindowTypeEnd

} MsgWindowType;

typedef struct t_MsgWindow *MsgWindow;

MsgWindow gj_gtk_mw_find_by_ri_id(gint id);
MsgWindow gj_gtk_mw_find_by_widget(GtkWidget *widget);
MsgWindow gj_gtk_mw_find_by_ri_id_and_type(gint id, MsgWindowType type);
MsgWindow gj_gtk_mw_find_by_last_msg_recv_xevent_id(gchar *message_id);
MsgWindow gj_gtk_mw_find_by_last_msg_sent_xevent_id(gchar *message_id);

/* 
 * member functions 
 */

/* gets */
gchar *gj_gtk_mw_get_jid(MsgWindow mw);
MsgWindowType gj_gtk_mw_get_type(MsgWindow mw);

gint gj_gtk_mw_get_last_msg_recv_xevent_type(MsgWindow mw);
gchar *gj_gtk_mw_get_last_msg_recv_xevent_id(MsgWindow mw);

gint gj_gtk_mw_get_last_msg_sent_xevent_type(MsgWindow mw);
gchar *gj_gtk_mw_get_last_msg_sent_xevent_id(MsgWindow mw);

/* sets */
gboolean gj_gtk_mw_set_jid(MsgWindow mw, gchar *jid);
gboolean gj_gtk_mw_set_type(MsgWindow mw, MsgWindowType type);

gboolean gj_gtk_mw_set_last_msg_recv_xevent_type(MsgWindow mw, gint type);
gboolean gj_gtk_mw_set_last_msg_recv_xevent_id(MsgWindow mw, gchar *id);

gboolean gj_gtk_mw_set_last_msg_sent_xevent_type(MsgWindow mw, gint type);
gboolean gj_gtk_mw_set_last_msg_sent_xevent_id(MsgWindow mw, gchar *id);

void gj_gtk_mw_print_all();
void gj_gtk_mw_print(MsgWindow mw);

/* window functions */
gboolean gj_gtk_mw_show(MsgWindow mw, gboolean show);

MsgWindow gj_gtk_mw_notification_new(gint eventID, message msg);
void gj_gtk_mw_default_action(rosterItem ri); 

MsgWindow gj_gtk_mw_send_new(rosterItem ri);
MsgWindow gj_gtk_mw_send_new_by_jid(gchar *jid); /* special cases */
MsgWindow gj_gtk_mw_receive_new(rosterItem ri);

gboolean gj_gtk_mw_waiting_next(MsgWindow mw);



#endif

#ifdef __cplusplus
}
#endif
