/* 
 * $RCSfile: gj_iq.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/12 11:25:41 $
 * 
 * $Revision: 1.4 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_iq_h
#define __gj_iq_h

#include <glib.h>

#include <libxml/tree.h>

#include "gj_connection.h"

/* 
 * Information Query
 */
typedef enum infoqueryType {
    infoqueryTypeNull = 0,
    infoqueryTypeGet,
    infoqueryTypeSet,
    infoqueryTypeResult,
    infoqueryTypeError,

    infoqueryTypeEnd
} infoqueryType;

typedef struct t_infoquery *infoquery;

typedef void (*infoqueryCallback)(guint id);

gboolean gj_iq_init();
gboolean gj_iq_term();

/* create / free */
infoquery gj_iq_new(infoqueryType type);
void gj_iq_free(infoquery iq);
void gj_iq_free_by_event_id(guint id);
void gj_iq_free_all_related_by_event_id(guint id);
void gj_iq_free_all_related_by_related_id(guint id);

/* formation */
gboolean gj_iq_build(infoquery iq, xmlNodePtr node);
gboolean gj_iq_build_from_list(infoquery iq, GList *nodes);
gboolean gj_iq_send(infoquery iq);

/*
 * members 
 */

/* set */
gboolean gj_iq_set_userdata(infoquery iq, void *userdata);
gboolean gj_iq_set_id(infoquery iq, gchar *id);
gboolean gj_iq_set_to(infoquery iq, gchar *to);
gboolean gj_iq_set_from(infoquery iq, gchar *from);
gboolean gj_iq_set_type(infoquery iq, infoqueryType type);
gboolean gj_iq_set_xml(infoquery iq, xmlNodePtr node);
gboolean gj_iq_set_callback(infoquery iq, infoqueryCallback cb);
gboolean gj_iq_set_event_id(infoquery iq, guint eventID);
gboolean gj_iq_set_related_id(infoquery iq, guint id);
gboolean gj_iq_set_associated_jid(infoquery iq, gchar *jid);

/* get */
void *gj_iq_get_userdata(infoquery iq);
gchar *gj_iq_get_id(infoquery iq);
gchar *gj_iq_get_to(infoquery iq);
gchar *gj_iq_get_from(infoquery iq);
infoqueryType gj_iq_get_type(infoquery iq);
xmlNodePtr gj_iq_get_xml(infoquery iq);
void *gj_iq_get_callback(infoquery iq);
guint gj_iq_get_event_id(infoquery iq);
guint gj_iq_get_related_id(infoquery iq);
gchar *gj_iq_get_associated_jid(infoquery iq);

/* finding */
infoquery gj_iq_find_by_id(gchar *id);
infoquery gj_iq_find_by_event_id(guint id);
infoquery gj_iq_find_by_related_id(guint id);

/* print */
void gj_iq_print_all();
void gj_iq_print(infoquery iq);

/* other - used by parser */
void gj_iq_receive(connection c, xmlNodePtr node);


/*
 * Roster information
 */
typedef void (*infoqueryRosterResponseProc)(GList *roster);

#endif

#ifdef __cplusplus
}
#endif
