/* 
 * $RCSfile: gj_iq_requests.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/13 09:29:18 $
 * 
 * $Revision: 1.6 $
 *
 */

#ifdef __cplusplus
extern "C" {
#if 0
}
#endif
#endif

#ifndef __gj_iq_requests_h
#define __gj_iq_requests_h

#include "gj_stream.h"
#include "gj_iq.h"

gboolean gj_iq_request_greeting(gchar *to, guint port, streamCallback cb_connected, streamCallback cb_disconnected, streamCallback cb_error);
gboolean gj_iq_request_goodbye(gchar *to);

gboolean gj_iq_request_auth_method(gchar *username, infoqueryCallback cb);
gboolean gj_iq_request_auth_with_plain_password(gchar *username, gchar *password, gchar *resource, infoqueryCallback cb);
gboolean gj_iq_request_auth_with_digest_password(gchar *username, gchar *password, gchar *resource, infoqueryCallback cb);
gboolean gj_iq_request_roster(infoqueryRosterResponseProc proc);
gboolean gj_iq_request_roster_remove_contact(gchar *jid, infoqueryCallback cb);
gboolean gj_iq_request_roster_add_contact(gchar *jid, gchar *name, GList *groups, infoqueryCallback cb);

gboolean gj_iq_request_vcard(gchar *to, infoqueryCallback cb, void *userdata);
gboolean gj_iq_request_version(gchar *to, infoqueryCallback cb, void *userdata);
gboolean gj_iq_request_time(gchar *to, infoqueryCallback cb, void *userdata);
gboolean gj_iq_request_last(gchar *to, infoqueryCallback cb, void *userdata);

gboolean gj_iq_request_password_change(gchar *to, gchar *password, infoqueryCallback cb);
gboolean gj_iq_request_user_change(gchar *jid, gchar *name, GList *group, infoqueryCallback cb);
gboolean gj_iq_request_vcard_change(gchar *fn,
				    gchar *given,
				    gchar *family,
				    gchar *nickname,
				    gchar *url,
				    gchar *tel,
				    gchar *email,
				    gchar *desc,
				    gchar *bday,
				    gchar *street,
				    gchar *extadd,
				    gchar *locality,
				    gchar *region,
				    gchar *pcode,
				    gchar *country,
				    gchar *orgname,
				    gchar *orgunit,
				    gchar *title,
				    gchar *role,
				    infoqueryCallback cb);

gboolean gj_iq_request_register_user(gchar *to, gchar *username, gchar *password, infoqueryCallback cb);
gboolean gj_iq_request_register(gchar *to, infoqueryCallback cb);
gboolean gj_iq_request_registration_requirements(gchar *to, infoqueryCallback cb);
gboolean gj_iq_request_registration(gchar *to, infoqueryCallback cb, ...);

gboolean gj_iq_request_unregister(gchar *to, infoqueryCallback cb);

gboolean gj_iq_request_agents(gchar *server, infoqueryCallback cb);

gboolean gj_iq_request_search_requirements(gchar *to, infoqueryCallback cb);
gboolean gj_iq_request_search(gchar *to, infoqueryCallback cb, ...);

/* responses */
void gj_iq_request_roster_cb(guint eventID);

#endif

#ifdef __cplusplus
}
#endif
