/* 
 * $RCSfile: gj_parser.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/23 22:14:24 $
 * 
 * $Revision: 1.5 $
 *
 */

#ifndef __gj_parser_h
#define __gj_parser_h

#include <libxml/tree.h>
#include <libxml/parser.h>

#include "gj_connection.h"

void gj_parser_push_input(connection c, gchar *buf, gint nBytes);
void gj_parser_push_input_from_connection(connection c, gchar *text);

gboolean gj_parser_push_output(xmlNodePtr node);
gboolean gj_parser_push_output_from_text(gchar *text);

/* stats */
gint gj_parser_doc_count_top_level_nodes(xmlDocPtr doc);
xmlNodePtr gj_parser_print_tree(xmlNodePtr node, gint depth);

/* finding values (and returning) */
xmlChar *gj_parser_find_by_attr_and_ret(xmlNodePtr node, xmlChar *attrname);
xmlChar *gj_parser_find_by_node_and_ret(xmlNodePtr node, xmlChar *text);
const xmlChar *gj_parser_find_by_ns_and_ret(xmlNodePtr node);

/* find parts of the tree */
xmlNodePtr gj_parser_find_by_node(xmlNodePtr node, xmlChar *text);
xmlNodePtr gj_parser_find_by_node_on_parent(xmlNodePtr node, xmlChar *text);
xmlNodePtr gj_parser_find_by_node_contents(xmlNodePtr node, xmlChar *contents);
xmlNodePtr gj_parser_find_by_node_with_attr(xmlNodePtr node, xmlChar *nodeName, xmlChar *attrName, xmlChar *attrVal);

xmlAttrPtr gj_parser_find_by_attr(xmlAttrPtr prop, xmlChar *text);
xmlNodePtr gj_parser_find_by_ns(xmlNodePtr node);

GList *gj_parser_find_by_node_and_ret_by_list(xmlNodePtr node, xmlChar *text);
GList *gj_parser_find_by_node_on_parent_and_ret_by_list(xmlNodePtr node, xmlChar *text);
GList *gj_parser_find_by_node_and_ret_contents_by_list(xmlNodePtr node, xmlChar *text);
GList *gj_parser_find_by_node_on_parent_and_ret_contents_by_list(xmlNodePtr node, xmlChar *text);

/* conversions */
gchar *gj_parser_get_str_from_node(xmlNodePtr node);        /* converts an xml tree into text */

const xmlChar *gj_parser_get_element(xmlNodePtr node);
const xmlChar *gj_parser_get_content(xmlNodePtr node);

#endif

