/* 
 * $RCSfile: gj_registration.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/13 13:20:45 $
 * 
 * $Revision: 1.4 $ 
 *
 */
#ifndef __gj_register_h
#define __gj_register_h

#include <glib.h> 

typedef struct t_registration *registration;

typedef void (*registrationCallback)(registration rgr, gint error_code, gchar *error_reason);
typedef void (*registrationRequestCallback)(registration rgr, gint error_code, gchar *error_reason);


/* list functions */
gboolean gj_registration_init();
gboolean gj_registration_term();

/* list functions */
GList *gj_registration_list_get();

/* item functions */
registration gj_registration_new();
void gj_registration_free(registration rgr);

/* find */
registration gj_registration_find_by_id(gchar *id);
registration gj_registration_find_by_to(gchar *to);
registration gj_registration_find_by_from(gchar *from);

/* sets */
gboolean gj_registration_set_iD(registration rgr, gchar *id);
gboolean gj_registration_set_to(registration rgr, gchar *to);
gboolean gj_registration_set_from(registration rgr, gchar *to);
gboolean gj_registration_set_instructions(registration rgr, gchar *instructions);
gboolean gj_registration_set_username(registration rgr, gchar *username);
gboolean gj_registration_set_password(registration rgr, gchar *password);
gboolean gj_registration_set_email(registration rgr, gchar *email);
gboolean gj_registration_set_require_username(registration rgr, gboolean required);
gboolean gj_registration_set_require_password(registration rgr, gboolean required);
gboolean gj_registration_set_require_email(registration rgr, gboolean required);
gboolean gj_registration_set_require_nickname(registration rgr, gboolean required);
gboolean gj_registration_set_key(registration rgr, gchar *key);
gboolean gj_registration_set_callback(registration rgr, registrationCallback cb);

/* gets */
gchar *gj_registration_get_iD(registration rgr);
gchar *gj_registration_get_to(registration rgr);
gchar *gj_registration_get_from(registration rgr);
gchar *gj_registration_get_instructions(registration rgr);
gchar *gj_registration_get_username(registration rgr);
gchar *gj_registration_get_password(registration rgr);
gchar *gj_registration_get_email(registration rgr);
gboolean gj_registration_get_require_username(registration rgr);
gboolean gj_registration_get_require_password(registration rgr);
gboolean gj_registration_get_require_email(registration rgr);
gboolean gj_registration_get_require_nickname(registration rgr);
gchar *gj_registration_get_key(registration rgr);
registrationCallback gj_registration_get_callback(registration rgr);

/*
 * parsing functions  
 */
gboolean gj_registration_request_requirements(gchar *server, registrationRequestCallback cb);
gboolean gj_registration_request(gchar *server, registrationRequestCallback cb, 
				 gchar *key, gchar *username, gchar *password, gchar *email, gchar *nickname);

#endif

