/* 
 * $RCSfile: gj_search.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/07/06 12:54:08 $
 * 
 * $Revision: 1.1 $ 
 *
 */
#ifndef __gj_register_h
#define __gj_register_h

#include <glib.h> 

typedef struct t_search *search;

typedef void (*searchCallback)(search rgr, gint error_code, gchar *error_reason);
typedef void (*searchRequestCallback)(search rgr, gint error_code, gchar *error_reason);


/* list functions */
gboolean searchInit();
gboolean searchTerm();

/* list functions */
GList *searchListGet();

/* item functions */
search searchNew();
void searchFree(search s);

/* find */
search searchFindByID(gchar *id);
search searchFindByTo(gchar *to);
search searchFindByFrom(gchar *from);

/* sets */
gboolean searchSetID(search s, gchar *id);
gboolean searchSetTo(search s, gchar *to);
gboolean searchSetFrom(search s, gchar *to);
gboolean searchSetInstructions(search s, gchar *instructions);
gboolean searchSetJID(search s, gchar *jid);
gboolean searchSetFirst(search s, gchar *first);
gboolean searchSetLast(search s, gchar *last);
gboolean searchSetNick(search s, gchar *nick);
gboolean searchSetEmail(search s, gchar *email);
gboolean searchSetAllowsFirst(search s, gboolean allowed);
gboolean searchSetAllowsLast(search s, gboolean allowed);
gboolean searchSetAllowsNick(search s, gboolean allowed);
gboolean searchSetAllowsEmail(search s, gboolean allowed);
gboolean searchSetKey(search s, gchar *key);
gboolean searchSetCallback(search s, searchCallback cb);

/* gets */
gchar *searchGetID(search s);
gchar *searchGetTo(search s);
gchar *searchGetFrom(search s);
gchar *searchGetInstructions(search s);
gchar *searchGetJID(search s);
gchar *searchGetFirst(search s);
gchar *searchGetLast(search s);
gchar *searchGetNick(search s);
gchar *searchGetEmail(search s);
gboolean searchGetAllowsFirst(search s);
gboolean searchGetAllowsLast(search s);
gboolean searchGetAllowsEmail(search s);
gboolean searchGetAllowsNickname(search s);
gchar *searchGetKey(search s);
searchCallback searchGetCallback(search s);

/*
 * parsing functions  
 */
gboolean searchRequestAllowsments(gchar *server, searchRequestCallback cb);
gboolean searchRequest(gchar *server, searchRequestCallback cb, 
		       gchar *first, gchar *last, gchar *nick, gchar *email);

#endif

