/* 
 * $RCSfile: gj_stream.h,v $
 *
 * $Author: ginxd $
 * $Date: 2003/08/02 09:46:18 $
 * 
 * $Revision: 1.7 $
 *
 */

#ifndef __gj_stream_h
#define __gj_stream_h

#include <libxml/tree.h>

#include "gj_connection.h"

/* 
 * Streams
 */
typedef struct t_stream *stream;

typedef void (*streamCallback)(stream stm, gint error);


gboolean gj_stream_init();
gboolean gj_stream_term();

/*
 * item functions
 */
stream gj_stream_new();
gboolean gj_stream_free(stream stm);

/* find */
stream gj_stream_find_by_id(gchar *id);
stream gj_stream_find_by_unique_id(guint id);
stream gj_stream_find_by_connection(connection c);
stream gj_stream_find_by_request_id(gint requestID);
stream gj_stream_find_by_to(gchar *to);

/*
 * member functions
 */

/* set */
gboolean gj_stream_set_to(stream stm, gchar *to);
gboolean gj_stream_set_port(stream stm, guint port);

gboolean gj_stream_set_connected_cb(stream stm, streamCallback cb);
gboolean gj_stream_set_disconnected_cb(stream stm, streamCallback cb);
gboolean gj_stream_set_error_cb(stream stm, streamCallback cb);

/* get */
gchar *gj_stream_get_id(stream stm);
guint gj_stream_get_unique_id(stream stm);
gint gj_stream_get_request_id(stream stm);

gchar *gj_stream_get_to(stream stm);
guint gj_stream_get_port(stream stm);

gchar *gj_stream_get_stream(stream stm);
xmlDocPtr gj_stream_get_xml(stream stm);

connection gj_stream_get_connection(stream stm);

/* building */
gboolean gj_stream_open(stream stm);  /* build then open the stream...! */
gboolean gj_stream_close(stream stm);
gboolean gj_stream_close_by_to(gchar *to);
gboolean gj_stream_send(stream stm, gchar *text);
gboolean gj_stream_send_by_to(gchar *to, gchar *text);

gboolean gj_stream_build(stream stm);

/* input from parser */
void gj_stream_receive(connection c, xmlNodePtr node);
void gj_stream_receive_error(connection c, xmlNodePtr node);

/*
 * debugging 
 */
void gj_stream_print_all();
void gj_stream_print(stream stm);

#endif

